﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Infragistics.Windows.DataPresenter;

namespace EditableGrid
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Widget> _widgets = new ObservableCollection<Widget>();

        public MainWindow()
        {
            InitializeComponent();
            //
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
            //
            this.xamDataGrid1.RecordAdded += new EventHandler<Infragistics.Windows.DataPresenter.Events.RecordAddedEventArgs>(XamDataGrid_RecordAdded);
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            this.xamDataGrid1.DataSource = _widgets;
        }

        void XamDataGrid_RecordAdded(object sender, Infragistics.Windows.DataPresenter.Events.RecordAddedEventArgs e)
        {
            if (this.xamDataGrid1.ActiveCell.Record.DataItem != null)
            {               
                // yeah, our object now exists!

                // but I can only get this to fire, if I edit the name column, not the ID column
            }
        }

        private void lkpEditor_ValueChanged(object sender, RoutedEventArgs e)
        {
            // yeah! user has looked up a new value. move new value into business object

            // BUT, does it even exist yet?
        }

        private void AddButton_Click(object sender, RoutedEventArgs e)
        {
            this.xamDataGrid1.ExecuteCommand(DataPresenterCommands.RecordLastOverall);
            this.xamDataGrid1.FieldLayoutSettings.AllowAddNew = true;
            this.xamDataGrid1.FieldLayoutSettings.AddNewRecordLocation = AddNewRecordLocation.OnBottom;
            this.xamDataGrid1.ExecuteCommand(DataPresenterCommands.RecordLastDisplayed);
            this.xamDataGrid1.ExecuteCommand(DataPresenterCommands.RecordNext);
            this.xamDataGrid1.ExecuteCommand(DataPresenterCommands.CellFirstInRecord);
            this.xamDataGrid1.ExecuteCommand(DataPresenterCommands.StartEditMode);
            
            // problem - why isn't the grid showing my add row?
        }


    }

    public class Widget
    {
        private string _id;
        private string _name;

        public string ID
        {
            get { return _id; }
            set { _id = value; }
        }

        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }


    }
}
